<!DOCTYPE html>

<html>

<head>

<meta name="viewport" content="initial-scale=1.0, user-scalable=no">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta charset="utf-8">

<!--The HTML document styling is set up.-->
<style type="text/css">
html, body, #map-canvas {
	height: 100%;
	margin: 0px;
	padding: 0px;
}
</style>

<!--The Google Maps API is referenced. If you have an API key, the next line should be replaced with the information provided by Google.-->
<script src="http://maps.google.com/maps/api/js?v=3.5&sensor=true"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>

<!--The map is set up with the code below.-->
<script type="text/javascript">  
	var geocoder;
	var map;
	var gmarkers = [];
	
	function initialize() {
		geocoder = new google.maps.Geocoder();
// If codeAddress is not needed to be called (i.e. there is always the same starting location) then this can be set here. Disable the "codeAddress();" line below.
		var latlng = new google.maps.LatLng(-34.397, 150.644);
// Various map styling is configured below. See Google documentation for options.
		var mapOptions = {
			zoom: 9,
			center: latlng,
			mapTypeId: google.maps.MapTypeId.ROADMAP,
			disableDefaultUI: true,
			zoomControl: true,
			zoomControlOptions: {
				style: google.maps.ZoomControlStyle.SMALL
			},
			mapTypeControlOptions: {
      				style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
    			},
		}
	
	map = new google.maps.Map(document.getElementById("map-canvas"), mapOptions);

// This sets the opening map location based on the values passed in the URL. Disable this if not required.
	codeAddress();

// This is the listener event waiting for a click to occur. When it does, the latitude and longitude are stored, the current marker pin is removed, the new marker is placed and the FileMaker script is called, sending in the coordinates as parameters. These are used in the script that is run to set the fields with the values.
	google.maps.event.addListener(map, "click", function(event) {
		var lat = event.latLng.lat();
		var lng = event.latLng.lng();
		removeMarkers();
		placeMarker(event.latLng);
// Set a variable called params with the latitude, longitude, record ID and secret key - record ID and secret key are passed in the URL when the map is loaded in the web viewer.
		var params = lat + "|" + lng + "|" + <?php echo $_GET['id']; ?> + "|" + "<?php echo $_GET['secretKey']; ?>"
// Trigger a script in FileMaker using the PHP API, sending in the parameters collected above.
		$( "#fmscript" ).load( "fmperformscript.php?params=" + params + "&-findall" );
	})
	}


// This function takes the values passed in the URL when the map is loaded in the web viewer and converts them to coordinates to center the map on this location.
	function codeAddress() {
		var address = document.getElementById("address").innerHTML;
		geocoder.geocode( { 'address': address}, function(results, status) {
			if (status == google.maps.GeocoderStatus.OK) {
				map.setCenter(results[0].geometry.location);
				// It is not required in this instance to drop a marker for the Start Address so the below is disabled
				//var marker = new google.maps.Marker({
					//map: map,
					//position: results[0].geometry.location
				//});
			} else {
				//alert("Geocode was not successful for the following reason: " + status);
				}
			});
	}


// This function is called when the map is clicked. It places the map marker in the location clicked. Various options are available including different marker icons, animation etc - see Google Maps documentation.
	function placeMarker(location) {
		var marker = new google.maps.Marker({
			position: location, 
			map: map,
			animation: google.maps.Animation.DROP
		});
		gmarkers.push(marker);
	}


// This function removes the current marker. It is called each time a click occurs prior to the placeMarker function that places the marker in the location just clicked.
	function removeMarkers(){
		for(i=0; i<gmarkers.length; i++){
			gmarkers[i].setMap(null);
		}
	}

</script>
</head>

<!-- This draws the map. -->
<body onload="initialize()">
	<div id="map-canvas"></div>
<!-- In the webviewer, the position of the map initially is based on the city and country passed in the URL when the map is loaded -->
	<div id="address" style="display: none;"><?php echo $_GET['city']; ?>, <?php echo $_GET['country']; ?></div>
<!-- This is our div for calling the PHP script -->
    <div id="fmscript"></div>
</body>

</html>
